from .view import View, Action
from colander import SchemaNode, String
from pyramid.httpexceptions import HTTPFound
from pyramid.view import view_config
import colander
import gocept.directory2.admin.form


@view_config(route_name='ipaddress_view',
             renderer='templates/ipaddress_view.pt')
class ViewIPAddress(View):

    @property
    def title(self):
        return self.context.address

    @property
    def actions(self):
        yield Action('Edit reverse DNS', 'icon-edit', 'ipaddress_edit',
                     id=self.context.id)


class Schema(colander.Schema):

    reverse = SchemaNode(
        String(), missing=None,
        title='Reverse DNS name (optional)',
        description='FQDNs need to have a trailing dot;'
        ' leave out trailing dot for relative domain names')


@view_config(route_name='ipaddress_edit')
class Edit(gocept.directory2.admin.form.Edit):

    schema = Schema()
    next_route = 'ipaddress_view'

    @property
    def title(self):
        return 'Address "%s"' % self.context.address


@view_config(route_name='ipaddress_deallocate')
class Deallocate(View):

    def __call__(self):
        self.context.nic = None
        return HTTPFound(location=self.request.route_url(
            'ipaddress_view', id=self.context.id))
