from gocept.directory2.network import Network
import gocept.directory2.admin.testing


class TestNetworkCRUD(gocept.directory2.admin.testing.BrowserTestCase):

    def test_add_network(self):
        b = self.browser
        b.open('http://localhost/location/list')
        b.getLink('loc0').click()
        b.getLink('Networks').click()
        b.getLink('srv').click()
        b.getLink('New network').click()
        cidr = '195.62.106.0/27'
        b.getControl('Network').value = cidr
        b.getControl(name='add').click()
        self.assertEllipsis('...added successfully...', b.contents)
        self.assertEllipsis('...%s...' % cidr, b.contents)

    def test_add_network_when_network_already_exists_in_vlan_fails(self):
        location = self.layer['loc0']._refresh()
        vlan = location.vlans['srv']
        CIDR = '195.62.106.0/27'
        Network.create(vlan=vlan, network=CIDR)
        self.assertEqual(1, len(vlan.networks))
        b = self.browser
        b.open('http://localhost/location/list')
        b.getLink('loc0').click()
        b.getLink('Networks').click()
        b.getLink('srv').click()
        b.getLink('New network').click()
        b.getControl('Network').value = CIDR
        b.getControl(name='add').click()
        self.assertEllipsis(
            '...Network %s already exists...' % CIDR, b.contents)
        self.assertEqual(1, len(vlan.networks))

    def test_edit_network(self):
        location = self.layer['loc0']._refresh()
        Network.create(vlan=location.vlans['srv'], network='195.62.106.0/27')
        b = self.browser
        b.open('http://localhost/location/list')
        b.getLink('loc0').click()
        b.getLink('Networks').click()
        b.getLink('srv').click()
        b.getLink('195.62.106.0/27').click()
        self.assertEllipsis('...VLAN...srv...', b.contents)
        b.getLink('Edit').click()
        b.getControl('DHCP dynamic range').selected = True
        b.getControl(name='save').click()
        self.assertEllipsis('...DHCP...True...', b.contents)
