# -*- coding: utf-8 -*-
import unittest


class IsAsciiTests(unittest.TestCase):
    """Testing ..schema.is_ascii()."""

    def callFUT(self, value):
        from ..schema import is_ascii
        from mock import sentinel
        return is_ascii(sentinel.node, value)

    def test_returns_None_on_ASCII_value(self):
        self.assertIsNone(self.callFUT(u'sadf'))

    def test_raises_Invalid_for_non_ASCII_value(self):
        from colander import Invalid
        with self.assertRaises(Invalid) as err:
            self.callFUT(u'Holzfäller')
        self.assertEqual(
            u'"Holzf\xe4ller" is not ASCII, which is required here.',
            err.exception.msg)
