import gocept.directory2.db_domainshuttle
from sqlalchemy import Column, Integer, String, Text, ForeignKey, orm


class Domain(gocept.directory2.db_domainshuttle.Object):

    __tablename__ = 'domain'

    id = Column(Integer, unique=True, nullable=False, primary_key=True)
    uid = Column(Integer, ForeignKey('user.uid'), nullable=False)
    subdom_of = Column(Integer, ForeignKey('domain.id'))
    _name = Column("name", String(50), nullable=False)
    idn_name = Column(String(255))
    descr = Column(Text)
    httpd_conf = Column(Integer, default=1, nullable=False)
    sendmail_cw = Column(Integer, default=1, nullable=False)
    named_conf = Column(Integer, default=1, nullable=False)
    rel_path = Column(String(255), nullable=False, default='')
    cname = Column(String(255))
    ip = Column(String(15))
    primary_dns = Column(String(64), default=u'ns1.gocept.com', nullable=False)
    second_dns = Column(String(50), default=u'ns2.gocept.com', nullable=False)
    freeRecords = Column(Text, default='', nullable='False')
    storeMailOn = Column(String(60), default='gocept06', nullable=False)

    user = orm.relation('User', uselist=False, backref='domains')
    subdomain_of = orm.relation(
        'Domain', backref='subdomains', remote_side=[id])

    @property
    def name(self):
        return self._name

    @name.setter
    def name(self, value):
        self._name = value
        idna = value.encode('idna')
        if idna != value:
            self.idn_name = idna


class User(gocept.directory2.db_domainshuttle.Object):

    __tablename__ = 'user'

    id = Column('uid', Integer, unique=True, nullable=False, primary_key=True)
    name = Column(String(16))
    customer_id = Column(Integer, default=0)
    realname = Column(String(40), default='')
